<template>
	<view class="">
		<view class="status_bar"></view>
		<view class="" style="position: relative;top: 40px;">
			<view style="position: fixed;z-index: 100;">
				<uni-nav-bar  @clickLeft="clickLeft" left-icon="back" left-text="返回"
				 ></uni-nav-bar>
				 <view class="bases_search">
				 	<view class="bases_search_text" @click="clickRight">
				 		<u-icon name="search" class="search" @click="search"></u-icon>
				 		<input type="text" v-model="data.search" placeholder="设备ID搜索" @input="searchinput" disabled/>
				 	</view>
				 </view>
				<view>
					<image :src="$imageURL+'/bigdata_app'+'/image/cb/banner.jpg'" mode="widthFix"></image>
				</view>
				<view class="tab-box">
					<!-- <view v-for="(item,index) in equipArr" :key="item.type" @click="tabClick(index,item)" :class="['tab-item',active==index?'active':'']">
						<text>{{item.type_name}}</text>
						<text class="bottom-line"></text>
					</view> -->
					<u-tabs :list="equipArr"  :current="active" active-color="#14A478" @change="tabClick"></u-tabs>
				</view>
			</view>
			<view class="loading" v-if="loadingtf">
				<image src="../../../static/images/ajax-loader.gif" mode="" class="img"></image>
			</view>
			<view class="" style="position: absolute;top: 190px;width: 100%;">
				<view class="content">
					<template v-for="(item,index) in equipArr[active].list" >
						<equipItem @click.native="itemClick(item)" v-bind:item="item" :key="index">
							<view class="date">
								<p>设备ID：{{item.imei||item.device_id}}</p>
								<p>最新上报时间：{{item.uptime|timeFormat}}</p>
								<view class="" style="display: flex;justify-content: space-between;" v-if="(device_type == 3 || device_type==7) && $QueryPermission(325)">
									<p>设备到期情况：<span
											:class="'prevents_item_bot_sapn'+item.device_expire">{{item.device_expiretext}}</span>
									</p>
									<p style="color: #3C84FE;" v-if="item.device_expire!=0"  @click.stop="examine(item)">查看详情</p>
								</view>
							</view>
						</equipItem>
					</template>
				</view>
			</view>
		</view>
		<u-modal v-model="show" :title="title" :showConfirmButton="false" :title-style="{'text-align':'left','padding-left':'10px','font-weight':700}" :mask-close-able="true">
			<view class="slot-content">
				<rich-text :nodes="content"></rich-text>
			</view>
		</u-modal>
		<view class="top">
			<view class="backtop" @click="top" v-if="isTop">
				<image src="../../../static/images/1.png" mode="" class="img0"></image>
			</view>
			
			<view class="more">
				<view class="box" @click="findSearch(1)" v-show="filtrateTF">
					<p>在线</p>
				</view>
				<view class="box" @click="findSearch(0)" v-show="filtrateTF">
					<p>离线</p>
				</view>
				<view class="box" @click="findSearch('')" v-show="filtrateTF">
					<p>全部</p>
				</view>
				<view @click="filtrate">
					<image src="../../../static/images/b0bcdb0e3fe8690520f743aa8303bf2.png" mode="" class="img1"></image>
				</view>
			</view>
			
			
		</view>
	</view>
</template>

<script>
	import equipItem from "../../../components/equip-item/equip-item"
	import uniNavBar from "@/components/uni-nav-bar/uni-nav-bar.vue"
	export default {
		data() {
			return {
				active: 0, //默认选中虫情测报
				equipArr: [{
					name: ''
				}],
				isTop: false,
				filtrateTF:false,
				device_status:"",
				loadingtf:false,//设备列表加载中
				device_type:3,
				show: false,
				title: "",
				content: "",
				searchinput:'',
				data:{search:''}
			}
		},
		computed:{
			tabActiveStyle(){
				return {
					color: '#303133',
					fontWeight: 'bold'
				}
			}
		},
		onLoad() {
			this.equipArr = [{
					name: ''
				}]
			this.usertype()
			
		},
		onShow() {

		},
		onHide() {

		},
		onUnload() {

		},
		onPullDownRefresh() {
			this.equipArr[this.active].pageIndex = 1
			this.equipArr[this.active].list = []
			if (this.active == 4) {
				this.getthxyEquipList(4)
			} else if (this.active == 5) {
				this.getxctEquipList(5)
			} else if (this.active == 3) {
				this.getxyEquipList(3)
			} else {
				this.getEquipList(this.active)
			}
			setTimeout(() => {
				uni.stopPullDownRefresh()
			}, 1000)
		},
		onReachBottom() {
			let act = this.active
			if (this.equipArr[act].list.length < this.equipArr[act].pageIndex * 10) { //判断是否数据请求完
				return false
			}
			this.equipArr[act].pageIndex++;
			if (this.active == 4) {
				this.getthxyEquipList(4)
			} else if (this.active == 5) {
				this.getxctEquipList(5)
			} else if (this.active == 3) {
				this.getxyEquipList(3)
			} else {
				this.getEquipList(this.active)
			}
		},
		onPageScroll(e) { //nvue暂不支持滚动监听，可用bindingx代替
			if (e.scrollTop > 200) { //距离大于200时显示
				this.isTop = true
			} else { //距离小于200时隐藏
				this.isTop = false
			}
		},
		onBackPress(options) {
			if (options.from === 'navigateBack') {
				return false;
			}
			this.clickLeft();
			return true;
		},
		methods: {
			search(){
				
			},
			//获取用户测报设备列表
			async usertype() { 
				const res = await this.$myRequest({
					url: '/api/api_gateway?method=home.homes.user_device_type',
					data:{
						model:'测报'
					}
				})
				console.log('设备列表',res)
				// this.equipArr = res
				this.equipArr.shift()
				res.forEach(item=>{
					item.name=item.type_name
					item.list = []
					item.pageIndex = 1
					this.equipArr.push(item)
				})
				if (res.length) {
					this.device_type =this.equipArr[0].id
					this.choosePOST()
				}
			},
			async getEquipList(act) {
				
				this.loadingtf = true
				const res = await this.$myRequest({
					url: '/api/api_gateway?method=forecast.worm_lamp.lamp_list',
					data: {
						device_type_id: this.equipArr[act].id,
						page: this.equipArr[act].pageIndex,
						page_size: 10,
						device_status:this.device_status,
						device_model: this.equipArr[act].device_model ? this.equipArr[act].device_model:0
					}
				})
				this.loadingtf =false
				console.log(res)
				this.equipArr[act].list = [...this.equipArr[act].list, ...res.data]
				this.equipArr[act].list.forEach(item => {
					item.uptime = item.addtime;
				})
				for (var i = 0; i < this.equipArr[act].list.length; i++) {
					if (this.equipArr[act].list[i].device_expire == 0) {
						this.equipArr[act].list[i]['device_expiretext'] = "未到期"
					} else if (this.equipArr[act].list[i].device_expire == 1) {
						this.equipArr[act].list[i]['device_expiretext'] = "已到期"
					} else if (this.equipArr[act].list[i].device_expire == 2) {
						this.equipArr[act].list[i]['device_expiretext'] = "即将到期"
					}
				}
				console.log('处理后的结果',this.equipArr[act].list)
			},
			// 性诱2.0
			async getxyEquipList(act) {
				this.loadingtf = true
				const res = await this.$myRequest({
					url: '/api/api_gateway?method=sex_lure_nl.sex_lure.nl_device_list',
					data: {
						device_type_id: this.equipArr[act].id,
						page: this.equipArr[act].pageIndex,
						page_size: 10,
						device_status:this.device_status
					}
				})
				this.loadingtf =false
				console.log(res)
				this.equipArr[act].list = [...this.equipArr[act].list, ...res.data]
				console.log(this.equipArr[act].list)
			},
			// 性诱3.0
			async getthxyEquipList(act) {
				this.loadingtf = true
				const res = await this.$myRequest({
					url: '/api/api_gateway?method=forecast.worm_lamp.xy_three_list',
					data: {
						device_type_id: this.equipArr[act].id,
						page: this.equipArr[act].pageIndex,
						page_size: 10,
						device_status: this.device_status,
					}
				})
				this.loadingtf = false
				console.log(res)
				this.equipArr[act].list = [...this.equipArr[act].list, ...res.data]
				console.log(this.equipArr[act].list)
			},
			// 吸虫塔
			async getxctEquipList(act) {
				this.loadingtf = true
				const res = await this.$myRequest({
					url: '/api/api_gateway?method=forecast.worm_lamp.xct_list',
					data: {
						device_type_id: this.equipArr[act].id,
						page: this.equipArr[act].pageIndex,
						page_size: 10,
						device_status: this.device_status,
					}
				})
				this.loadingtf = false
				console.log(res)
				this.equipArr[act].list = [...this.equipArr[act].list, ...res.data]
				console.log(this.equipArr[act].list)
			},
			tabClick(index) {
				
				this.active = index;
				this.device_type = this.equipArr[index].id
				this.equipArr[this.active].list = []
				this.equipArr[this.active].pageIndex=1
				this.choosePOST()
			},
			
			choosePOST(){
				let index = this.active
				let typeId = this.device_type
				if(typeId == 10){
					// 性诱2.0
					this.getxyEquipList(index)
				}else if(typeId == 8){
					// 性诱3.0
					this.getthxyEquipList(index)
				}else if(typeId == 12){
					// 吸虫塔
					this.getxctEquipList(index)
				}
				else{
					// 测报接口
					this.getEquipList(index)
				}
			},
			clickRight() {
				console.log('点击了搜索')
				uni.navigateTo({
					url: "./search?device_type_id=" + this.device_type+'&pur_id=' + this.equipArr[this.active].pur_id
				})
			},
			itemClick(itemOld) {
				let item = JSON.parse(JSON.stringify(itemOld))
				item.type= this.equipArr[this.active].id
				item.pur_id = this.equipArr[this.active].pur_id||0
				let data = JSON.stringify(item)
			
				console.log('item',item)
				if (item.type == 10) {
					uni.navigateTo({
						url: '/pages/cb/xy2.0/particulars?info=' + data
					});
				} else if (item.type == 8) {
					console.log(data)
					uni.navigateTo({
						url: '/pages/cb/thxydetail/thxydetail?imei=' + item.imei
					});
				} else if (item.type == 12) {
					uni.navigateTo({
						url: '/pages/cb/xctdetail/xctdetail?info=' + data
					});
				} else if (item.type == 14) {
					uni.navigateTo({
						url: '/pages/cb/sy/detail?detail=' + data
					});
				}else if (item.type == 24) {
					uni.navigateTo({
						url: '/pages/cb/zjxydetail/thxydetail?imei=' + item.imei
					});
				}else if (item.type == 25) {
					uni.navigateTo({
						url: '/pages/cb/xylps/detail?detail=' + data
					});
				}else if (item.type == 28) {
					uni.navigateTo({
						url: '/pages/cb/smallPest/smallPest?info=' + data
					});
				}else if (item.type == 29) {
					uni.navigateTo({
						url: `/pages/cb/nlNewXy/nlNewXy?imei=${item.imei}&showId=${item.only_for_show}`
					});
				}else if (item.type == 32||item.type == 33||item.type == 34||item.type == 35) {
					uni.navigateTo({
						url: '/pages/cb/equip-detail/equip-detail-new?info=' + data
					});
				} else{
					uni.navigateTo({
						url: '/pages/cb/equip-detail/equip-detail?info=' + data
					});
				}
			},
			clickLeft() {
				uni.switchTab({
					url: "../../index/index"
				})
			},
			filtrate(){
				this.filtrateTF = !this.filtrateTF
			},
			top() {
				uni.pageScrollTo({
					scrollTop: 0,
					duration: 500
				})
			},
			findSearch(device_status){
				
				this.device_status = device_status	
				this.equipArr[this.active].pageIndex=1
				this.equipArr[this.active].list =[]
				this.choosePOST()
				this.filtrateTF = !this.filtrateTF
			},
			examine(e) {
				// console.log(this)
				this.show = true
				this.title = e.device_expiretext
				this.content = `<p style="padding-left:10px;margin:10px 0;font-size:14px;">到期时间  ${this.timezhuan(e.device_expire_time)}
				</p><p style="font-size:14px;text-align:right;color:#3C84FE;margin-bottom:10px;padding-right:10px">注：请前往PC端进行充值</p>`
			},
			timezhuan(time) {
				function fun(a) {
					return String(a).length == 1 ? '0' + a : a
				}
				let date = new Date(time * 1000)
				let y = date.getFullYear()
				let m = date.getMonth() + 1
				let d = date.getDate()
				let h = date.getHours()
				let min = date.getMinutes()
				let sec = date.getSeconds()
				return `${y}-${fun(m)}-${fun(d)} ${fun(h)}:${fun(min)}:${fun(sec)}`
			},
		},
		components: {
			equipItem,
			uniNavBar
		}
	}
</script>

<style lang="scss">
	page {
		background: $uni-bg-color-grey;

		.content {
			padding: 0 20rpx 20rpx 20rpx;
			box-sizing: border-box;
		}
	}

	image {
		width: 100%;
	}
	.loading{
		position: fixed;
		top: 440px;
		width: 95%;
		left: 2.5%;
		text-align: center;
		z-index: 100;
		.img{
			width: 300rpx;
			height: 40rpx;
		}
	}
	.bases_search {
		width: 80%;
		background-color: #FFFFFF;
		position: absolute;
		top: 10rpx;
		left: 50%;
		margin-left: -33%;
		.bases_search_text {
			width: 90%;
			margin: 0 auto;
			background-color: #F8F8F8;
			height: 60rpx;
			border-radius: 30rpx;
			display: flex;
			line-height: 60rpx;
	
			.search {
				padding: 0 20rpx;
				font-size: 34rpx;
			}
	
			input {
				width: 80%;
				margin-top: 10rpx;
				font-size: 28rpx;
			}
		}
	}
	.tab-box {
		font-size: 30rpx;
		line-height: 80rpx;
		background-color: #ffffff;
		width: 100vw;
		z-index: 2;
		margin-top: -10rpx;		
	}

	.top {
		position: fixed;
		right: 10px;
		bottom: 40px;
		z-index: 100;
		image {
			width: 100rpx;
			height: 100rpx;
		}
		.backtop{
			display: flex;
			justify-content: flex-end;
			margin-bottom: 10rpx;
		}
		.more{
			display: flex;
		}
		.box{
			width: 80rpx;
			height: 80rpx;
			background-color: rgba(161,161,161,0.45);
			border-radius: 50%;
			text-align: center;
			line-height: 80rpx;
			box-sizing: border-box;
			margin: 14rpx 10rpx 0 0;
			color: #fff;
		}
	}
</style>
